## Что это?
**VK Offline** - это legacy packaged app для браузеров, работающих на базе Chromium (Google Chrome, Яндекс.Браузер, Chromium ит.д.). VK Offline можно установить из [Chrome Web Store](https://chrome.google.com/webstore/detail/vkontakte-offline/jinklgkideaicpdgmomlckebafjfibjk) или со [страницы разработчика](http://staypositive.ru/vkofflineapp-promo).

## Как начать разрабатывать
 * Склонируйте репозиторий к себе на компьютер
 * Установите [node.js](http://nodejs.org/download/)
 * Установите [Grunt](http://gruntjs.com/)
 * ```npm install && grunt```

## Зачем в проекте grunt?
 * Для сборки файлов локализации из одного файла locales.json: ```grunt i18n```
 * Для сборки Vanilla JS шаблонов для Hogan.js: ```grunt templates```
 * Для релизной сборки: ```grunt i18n templates release```

## FAQ
 * **Как мне добавить локализацию?**
Откройте issue в [багтрекере](https://github.com/1999/vkoffline/issues?sort=created&state=open), после чего форкните репозиторий, внесите фикс в файл i18n/locales.json и пришлите pull-запрос.
 * **Это приложение позволяет сидеть ВКонтакте в режиме offline?**
К сожалению нет. VK Offline - это e-mail клиент и адресная книга на основе данных ваших профилей ВКонтакте. Также приложение предоставляет доступ к вашим контактам и переписке при отсутствии интернета.
 * **Время отстает на час**
Вам следует установить обновления для вашей ОС Windows, поскольку некоторое время назад переход на летнее/зимнее время был отменен, и это отразилось на работе Windows.
 * **Ключ устарел. Что делать?**
Вам следует зайти в настройки и обновить ключ доступа. Кнопка обновления ключа доступа находится напротив вашего аккаунта.
 * **Я диктую текст на русском, а получаю на другом языке. Что делать?**
Вам нужно зайти в настройки браузера на [эту страницу](chrome://settings/languages) и установить нужный вам языке первым в списке.
 * **Установка приложения отменена т. к. оно не подерживается на вашем компьютере**
VK Offline работает на Chromium 22 версии и выше. Если вы видите эту надпись, значит ваш браузер устарел и вам следует его обновить.
 * **Можно ли восстановить сообщения, удаленные в ВКонтакте?**
Вкратце - нет. Но если вы синхронизировали сообщения до удаления на сайте, то они останутся у вас в приложении.
 * **Как запустить приложение при работающем Speed Dial?**
Расширение Speed Dial не показывает список установленных приложений, поэтому рекомендую вам установить его более функциональные аналоги: [Speed Dial 2 ](https://chrome.google.com/webstore/detail/speed-dial-2/jpfpebmajhhopeonhlcgidhclcccjcik)или [Визуальные Закладки от Яндекса](https://chrome.google.com/webstore/detail/pchfckkccldkbclgdepkaonamkignanh).
 * **Почему не расшифровывается украинская речь?**
Приложение использует технологию [Google Voice Search](http://en.wikipedia.org/wiki/Google_Voice_Search), которая на данный момент не поддерживает украинский язык.

## Опенсорс FAQ
```
- Сделай мне эту фичу. Иначе я буду использовать другой проект»
Нет.

- Без данной функциональности этот проект бесполезен
Это ваше личное мнение

- Ты все делаешь не так. Отдай нам проект иначе ты его загубишь
Форкайте.

- Твой код отстой, мы напишем все намного лучше
Пишите

- Я все делал не по инструкции. Почему у меня ничего не работает? Ненавижу вас
Делайте по инструкции. Мне всё равно как вы ко мне относитесь.

- Вы должны...
Нет.

- Я требую...
Платите деньги.
```

[Источник](http://habrahabr.ru/post/169339/#comment_5872463)

## Автор

 * [Дмитрий Сорин](http://www.staypositive.ru)

## Лицензия

Copyright 2013 Dmitry Sorin - info@staypositive.ru

Licensed under the Apache License, Version 2.0: http://www.apache.org/licenses/LICENSE-2.0
